Jack2: Reading and writing MIDI data

Jack2 1.9.21

Functions
Reading and writing MIDI data

## Functions
uint32_t | jack_midi_get_event_count (void *port_buffer) JACK_OPTIONAL_WEAK_EXPORT
int | jack_midi_event_get (jack_midi_event_t *event, void *port_buffer, uint32_t event_index) JACK_OPTIONAL_WEAK_EXPORT
void | jack_midi_clear_buffer (void *port_buffer) JACK_OPTIONAL_WEAK_EXPORT
void | jack_midi_reset_buffer (void *port_buffer) JACK_OPTIONAL_WEAK_DEPRECATED_EXPORT
size_t | jack_midi_max_event_size (void *port_buffer) JACK_OPTIONAL_WEAK_EXPORT
jack_midi_data_t * | jack_midi_event_reserve (void *port_buffer, jack_nframes_t time, size_t data_size) JACK_OPTIONAL_WEAK_EXPORT
int | jack_midi_event_write (void *port_buffer, jack_nframes_t time, const jack_midi_data_t *data, size_t data_size) JACK_OPTIONAL_WEAK_EXPORT
uint32_t | jack_midi_get_lost_event_count (void *port_buffer) JACK_OPTIONAL_WEAK_EXPORT

## Detailed Description

## Function Documentation

## ◆ jack_midi_get_event_count()

uint32_t jack_midi_get_event_count | ( | void * | port_buffer | ) |

Get number of events in a port buffer.

Parameters

  port_buffer | Port buffer from which to retrieve event.

Returns
  number of events inside port_buffer

## ◆ jack_midi_event_get()

int jack_midi_event_get | ( | jack_midi_event_t * | event,
|  | void * | port_buffer,
|  | uint32_t | event_index
| ) |  |

Get a MIDI event from an event port buffer.

Jack MIDI is normalised, the MIDI event returned by this function is guaranteed to be a complete MIDI event (the status byte will always be present, and no realtime events will interspered with the event).

This rule does not apply to System Exclusive MIDI messages since they can be of arbitrary length. To maintain smooth realtime operation such events CAN be deliverd as multiple, non-normalised events. The maximum size of one event "chunk" depends on the MIDI backend in use. For example the midiseq driver will create chunks of 256 bytes. The first SysEx "chunked" event starts with 0xF0 and the last delivered chunk ends with 0xF7. To receive the full SysEx message, a caller of jack_midi_event_get() must concatenate chunks until a chunk ends with 0xF7.

Parameters

  event | Event structure to store retrieved event in.
  port_buffer | Port buffer from which to retrieve event.
  event_index | Index of event to retrieve.

Returns
  0 on success, ENODATA if buffer is empty.

## ◆ jack_midi_clear_buffer()

void jack_midi_clear_buffer | ( | void * | port_buffer | ) |

Clear an event buffer.

This should be called at the beginning of each process cycle before calling jack_midi_event_reserve or jack_midi_event_write. This function may not be called on an input port's buffer.

Parameters

  port_buffer | Port buffer to clear (must be an output port buffer).

## ◆ jack_midi_reset_buffer()

void jack_midi_reset_buffer | ( | void * | port_buffer | ) |

Reset an event buffer (from data allocated outside of JACK).

This should be called at the beginning of each process cycle before calling jack_midi_event_reserve or jack_midi_event_write. This function may not be called on an input port's buffer.

Deprecated:
  Please use jack_midi_clear_buffer().

Parameters

  port_buffer | Port buffer to reset.

## ◆ jack_midi_max_event_size()

size_t jack_midi_max_event_size | ( | void * | port_buffer | ) |

Get the size of the largest event that can be stored by the port.

This function returns the current space available, taking into account events already stored in the port.

Parameters

  port_buffer | Port buffer to check size of.

## ◆ jack_midi_event_reserve()

jack_midi_data_t * jack_midi_event_reserve | ( | void * | port_buffer,
|  | jack_nframes_t | time,
|  | size_t | data_size
| ) |  |

Allocate space for an event to be written to an event port buffer.

Clients are to write the actual event data to be written starting at the pointer returned by this function. Clients must not write more than data_size bytes into this buffer. Clients must write normalised MIDI data to the port - no running status and no (1-byte) realtime messages interspersed with other messages (realtime messages are fine when they occur on their own, like other messages).

Events must be written in order, sorted by their sample offsets. JACK will not sort the events for you, and will refuse to store out-of-order events.

Parameters

  port_buffer | Buffer to write event to.
  time | Sample offset of event.
  data_size | Length of event's raw data in bytes.

Returns
  Pointer to the beginning of the reserved event's data buffer, or NULL on error (ie not enough space).

## ◆ jack_midi_event_write()

int jack_midi_event_write | ( | void * | port_buffer,
|  | jack_nframes_t | time,
|  | const jack_midi_data_t * | data,
|  | size_t | data_size
| ) |  |

Write an event into an event port buffer.

This function is simply a wrapper for jack_midi_event_reserve which writes the event data into the space reserved in the buffer.

Clients must not write more than data_size bytes into this buffer. Clients must write normalised MIDI data to the port - no running status and no (1-byte) realtime messages interspersed with other messages (realtime messages are fine when they occur on their own, like other messages).

Events must be written in order, sorted by their sample offsets. JACK will not sort the events for you, and will refuse to store out-of-order events.

Parameters

  port_buffer | Buffer to write event to.
  time | Sample offset of event.
  data | Message data to be written.
  data_size | Length of data in bytes.

Returns
  0 on success, ENOBUFS if there's not enough space in buffer for event.

## ◆ jack_midi_get_lost_event_count()

uint32_t jack_midi_get_lost_event_count | ( | void * | port_buffer | ) |

Get the number of events that could not be written to port_buffer.

This function returning a non-zero value implies port_buffer is full. Currently the only way this can happen is if events are lost on port mixdown.

Parameters

  port_buffer | Port to receive count for.

Returns
  Number of events that could not be written to port_buffer.